VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Reg Operations"
   ClientHeight    =   4815
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5460
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4815
   ScaleWidth      =   5460
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdWrite 
      Caption         =   "Write to Registry"
      Height          =   555
      Left            =   315
      TabIndex        =   14
      Top             =   3855
      Width           =   1995
   End
   Begin VB.CommandButton cmdRead 
      Caption         =   "Read Registry"
      Height          =   555
      Left            =   3135
      TabIndex        =   13
      Top             =   3855
      Width           =   1995
   End
   Begin VB.PictureBox Picture1 
      Height          =   300
      Left            =   45
      ScaleHeight     =   240
      ScaleWidth      =   5265
      TabIndex        =   12
      Top             =   4500
      Width           =   5325
      Begin VB.Label lblStatus 
         Height          =   240
         Left            =   15
         TabIndex        =   15
         Top             =   0
         Width           =   5265
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   " Value "
      Height          =   645
      Left            =   90
      TabIndex        =   10
      Top             =   3100
      Width           =   5280
      Begin VB.TextBox txtValue 
         Height          =   330
         Left            =   75
         TabIndex        =   11
         Top             =   210
         Width           =   5130
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   " Branch "
      Height          =   1530
      Left            =   90
      TabIndex        =   5
      Top             =   1500
      Width           =   5280
      Begin VB.TextBox txtKeyName 
         Height          =   285
         Left            =   1005
         TabIndex        =   9
         Text            =   "CompanyName"
         Top             =   1035
         Width           =   4155
      End
      Begin VB.TextBox txtParentKey 
         Height          =   285
         Left            =   75
         TabIndex        =   7
         Text            =   "Software\MyCompany"
         Top             =   540
         Width           =   5100
      End
      Begin VB.Label Label2 
         AutoSize        =   -1  'True
         Caption         =   "KeyName :"
         Height          =   195
         Left            =   105
         TabIndex        =   8
         Top             =   1080
         Width           =   780
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Branch Name or Parent Key :"
         Height          =   195
         Left            =   120
         TabIndex        =   6
         Top             =   270
         Width           =   2070
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   " HKEY "
      Height          =   1320
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   5280
      Begin VB.OptionButton optHU 
         Caption         =   "HKEY_USERS"
         Enabled         =   0   'False
         Height          =   270
         Left            =   2955
         TabIndex        =   4
         Top             =   885
         Width           =   1425
      End
      Begin VB.OptionButton optHKLM 
         Caption         =   "HKEY_LOCAL_MACHINE"
         Height          =   195
         Left            =   2955
         TabIndex        =   3
         Top             =   405
         Value           =   -1  'True
         Width           =   2175
      End
      Begin VB.OptionButton optHKCU 
         Caption         =   "HKEY_CURRENT_USER"
         Height          =   300
         Left            =   195
         TabIndex        =   2
         Top             =   885
         Width           =   2205
      End
      Begin VB.OptionButton optHKCR 
         Caption         =   "HKEY_CLASSES_ROOT"
         Height          =   210
         Left            =   195
         TabIndex        =   1
         Top             =   405
         Width           =   2115
      End
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   5460
      Y1              =   4455
      Y2              =   4455
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' Author Kdotkannan@yahoo.com /hotmail.com
' Go through Readme.txt for more details about this component

Option Explicit

Const sQuote = """"
Const sSpace = " "
Const TempFile = "C:\Temp\delthis.reg"
Const PathSeperator = "\"

'Root Key constants
Const HKCU = "HKEY_CURRENT_USER"
Const HKLM = "HKEY_LOCAL_MACHINE"
Const HKCR = "HKEY_CLASSES_ROOT"
Const HKU = "HKEY_USERS"

' Registry Operations
Const RegEditRead = "RegEdit /SE"           ' SE stands for Regedit Export in Silent Mode. ie user wont get confirm message.
Const RegEditWrite = "RegEdit /SC"          ' SC stands for Regedit Import in Silent Mode.
Const RegEd = "REGEDIT4"

' API declars
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

' Modular vars
Dim sRootKey As String


Private Sub cmdRead_Click()
' Get data from registry through regedit and extract data through api
On Error GoTo ErrRead
Dim sCmdLine As String

    ' Give msg box if fields are blank
    If txtParentKey.Text = "" Then MsgBox "Enter parent key": txtParentKey.SetFocus: Exit Sub
    If txtKeyName.Text = "" Then MsgBox "Enter key Name": txtKeyName.SetFocus: Exit Sub
    
    lblStatus.Caption = "Reading Under Progress"
    
    ' Call GetKeyValue fn to get the result
    txtValue.Text = GetKeyValue(txtParentKey.Text, txtKeyName.Text)
    lblStatus.Caption = "Registry Read Operation Over"
    Exit Sub
ErrRead:
    MsgBox "Err Read : " + Err.Description
    lblStatus.Caption = ""
End Sub

Private Sub cmdWrite_Click()
' Write data to file and import to registry through regedit
On Error GoTo ErrWrite
        
    Dim sCmdLine As String
        
    ' check for field null
    txtParentKey.Text = Trim$(txtParentKey.Text)
    If txtParentKey.Text = "" Then MsgBox "Enter parent key": txtParentKey.SetFocus: Exit Sub
    
    txtKeyName.Text = Trim$(txtKeyName.Text)
    If txtKeyName.Text = "" Then MsgBox "Enter key Name": txtKeyName.SetFocus: Exit Sub
    
    txtValue.Text = Trim$(txtValue.Text)
    If txtValue.Text = "" Then MsgBox "Enter value": txtValue.SetFocus: Exit Sub
    
    lblStatus.Caption = "Writing Under Progress"
    ' Prepare the file
    Call WriteFile(txtParentKey.Text, txtKeyName.Text, txtValue.Text)
    
    sCmdLine = RegEditWrite
    sCmdLine = sCmdLine + sSpace + sQuote + TempFile + sQuote
    'sCmdLine will become like this : regedit /SC "C:\temp\delthis.reg"
    
    Call Shell(sCmdLine)
    lblStatus.Caption = "Registry Write Operation Over"
    Exit Sub
ErrWrite:
    lblStatus.Caption = ""
    MsgBox "Reg write operation failed. Reason : " + Err.Description
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then KeyAscii = 0      ' avoid enter chars
End Sub

Private Sub Form_Load()
    optHKLM_Click       ' Default value
End Sub

' Assign the Root Keys
Private Sub optHKCR_Click()
    sRootKey = HKCR
End Sub

Private Sub optHKCU_Click()
    sRootKey = HKCU
End Sub

Private Sub optHKLM_Click()
    sRootKey = HKLM
End Sub

Private Sub optHU_Click()
    sRootKey = HKU
End Sub

Sub WriteFile(ByVal sParentKey As String, ByVal sKeyname As String, ByVal sKeyValue As String)
' write the data to the temporary file
    Dim lRet As Long
    Dim iFileNum As Integer
    
    If (Mid$(sParentKey, 1, 1)) = PathSeperator Then
        sParentKey = Mid(sParentKey, 2, Len(sParentKey) - 1)      ' Remote the first "\" char
    End If

    If (Mid$(sParentKey, Len(sParentKey), 1)) = PathSeperator Then
        sParentKey = Mid(sParentKey, 1, Len(sParentKey) - 1)      ' Remote the last "\" char
    End If
    
    If (Mid$(sKeyname, Len(sKeyname), 1)) = PathSeperator Then
        sKeyname = Mid(sKeyname, 1, Len(sKeyname) - 1)      ' Remote the last "\" char
    End If
    
    sKeyValue = Trim$(sKeyValue)
    sKeyname = sQuote + sKeyname + sQuote
        
'    If LCase(Mid$(sKeyValue, 1, 6) <> "dword:") Or LCase(Mid$(sKeyValue, 1, 4) <> "hex:") Then
        sKeyValue = sQuote + sKeyValue + sQuote
'    End If
    
    sParentKey = sRootKey + PathSeperator + sParentKey
        
    If Dir(TempFile, vbNormal) <> "" Then                        ' Let delete the temporary file if any
        Call SetAttr(TempFile, vbNormal)
        Kill TempFile
    End If
    
    iFileNum = FreeFile(0)
    Dim sStr As String
    sStr = RegEd
    
    Open TempFile For Append As #iFileNum
        Print #iFileNum, RegEd                                  ' write regedit4 into first line of file. Then only regedit will understand this file
    Close iFileNum
    
    lRet = WritePrivateProfileString(sParentKey, sKeyname, sKeyValue, TempFile)     'write the information we want to enter to registry

End Sub

Function GetKeyValue(ByVal sParentKey As String, ByVal sKeyname As String)
' Return the key value the user requested

    Dim lRet As Long
    Dim iFileNum As Integer
    Dim sCmdLine As String
    Dim sRetStr As String * 500
    Dim iLocCounter As Integer
    Dim sTemp As String
    

    If (Mid$(sParentKey, 1, 1)) = PathSeperator Then
        sParentKey = Mid(sParentKey, 2, Len(sParentKey) - 1)      ' Remove the first "\" char
    End If

    If (Mid$(sParentKey, Len(sParentKey), 1)) = PathSeperator Then
        sParentKey = Mid(sParentKey, 1, Len(sParentKey) - 1)      ' Remove the last "\" char
    End If
    
    sParentKey = sRootKey + PathSeperator + sParentKey
        
    If Dir(TempFile, vbNormal) <> Null Then                        ' Delete if the file already exist
        Call SetAttr(TempFile, vbNormal)
        Kill TempFile
    End If
    
    sCmdLine = RegEditRead + sSpace + sQuote + TempFile + sQuote + sSpace + sQuote + sParentKey + sQuote
    'sCmdLine becomes : RegEdit /SE "C:\Temp" "HKEY_LOCAL_MACHINE\My Folder\Mydata"
    
    Call Shell(sCmdLine)
    
    If iLocCounter = 0 Then sKeyname = sQuote + sKeyname + sQuote
ReadFile:
    lRet = GetPrivateProfileString(sParentKey, sKeyname, "", sRetStr, 500, TempFile)
    sTemp = Mid$(sRetStr, 1, lRet)
    If sTemp = "" Then                      ' Try to get the default value of the parent key
        iLocCounter = iLocCounter + 1
        If iLocCounter < 2 Then
            sKeyname = "@"
            GoTo ReadFile
        End If
    End If
    If iLocCounter > 0 Then
        GetKeyValue = "Default: " + sTemp
    Else
        GetKeyValue = sTemp
    End If
    
    
End Function
